<template>
    <div id="CreateUser" class="component">
        <div>
            <h1>Création d'un utilisateur :</h1>
            <label class="label">Pseudo</label>
            <input class="control" type="text" v-model="user_name" />
        </div>
        <div>
            <label>Adresse Mail</label>
            <input type="email" v-model="mail" />
        </div>
        <div>
            <label>Date de naissance</label>
            <input type="date" min="1899-01-01" max="2020-12-12" v-model="DoB" />
        </div>
        <div>
            <input type="submit" value="Create User" v-on:click="createUser" />
        </div>
        <pre><code>{{user}}</code></pre>
    </div>
</template>

<script>
    import axios from 'axios';

    export default {
        name: 'CreateUser',
        data: () => ({
            user_name: '',
            mail: '',
            DoB: '',
            user: '',
            reg: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/
        }),
        methods: {
            createUser: function() {
                if(!this.reg.test(this.mail)){
                    this.user = "L'adresse email est invalide";
                }else {
                    let date = this.DoB.split('-');
                    date = date.reverse();
                    date = date.join('');
                    this.user = this.user_name + ' ' + this.mail + ' ' + date;

                    let body = {
                        pseudo: this.user_name,
                        email: this.mail,
                        DoB: date
                    };

                    axios({
                        method: 'post',
                        url: 'http://127.0.0.1:8000/api/users',
                        data: body
                    }).then(response => (this.user = response.data),
                        (error) => (this.user = error.response.data));
                    location.reload();
                }
            }
        }
    }
</script>